# Embeddings models for Buddhist Sanskrit

Code for experiments presented in the paper 'Embeddings models for Buddhist Sanskrit' published in LREC 2022 proceedings.

# Funding

This work received funding from the NEH (HAA-277246-21).


## Installation, documentation ##

Instructions for installation assume the usage of PyPI package manager.<br/>

Install dependencies if needed: pip install -r requirements.txt <br/>

#### Prepare the data :<br/> 

The script preprocess.py accepts the folder containing the Buddhist Sanksrit corpus and returns the preprocessed corpus 
in the tsv format and language model train and test set written to the output folder:<br/>

```
python preprocess.py  --data_path 'resources/BuddhCorpus_v2c_IncludesReconstructions_2021-11-11' --output_folder resources
```


#### Train a tokenizer :<br/> 

After that we can train the tokenizer by running:<br/>

```
python train_tokenizer.py  --files 'resources/train_reference_corpus_processed.txt,resources/test_reference_corpus_processed.txt,resources/lm_train.txt,resources/lm_test.txt' --out tokenizers/sanskrit.json
```

The --files argument accepts txt files on which to train the tokenizer separated by comma and returns a trained model written to the file defined by the --out argument.

#### Train language model:<br/>

Train masked BERT language model on the reference corpus:<br/>

```
python fine-tune-mlm.py --output_dir models_reference_corpus --train_file resources/train_reference_corpus_processed.txt --validation_file resources/test_reference_corpus_processed.txt --model_type bert --tokenizer_name tokenizers/sanskrit.json --do_train true --do_eval true --per_device_train_batch_size 24 --per_device_eval_batch_size 4 --evaluation_strategy steps --save_steps 20000 --num_train_epochs 300 --max_seq_length 512 --eval_steps 20000 --overwrite_cache
```

Fine-tune masked BERT language model on the buddhist sanskrit corpus:<br/>

```
python fine-tune-mlm.py --train_file resources/lm_train.txt --validation_file resources/lm_test.txt --output_dir models_reference_corpus_fine_tuned --model_name_or_path models_reference_corpus --do_train true --do_eval true --per_device_train_batch_size 24 --per_device_eval_batch_size 4 --save_steps 20000 --num_train_epochs 300 --max_seq_length 512 --evaluation_strategy steps --eval_steps 20000 --overwrite_cache
```

Train causal GPT-2 language model on the reference corpus:<br/>

```
python fine-tune-clm.py --output_dir models_reference_corpus_gpt2 --train_file resources/train_reference_corpus_processed.txt --validation_file resources/test_reference_corpus_processed.txt --model_type gpt2 --tokenizer_name tokenizers/sanskrit.json --do_train true --do_eval true --per_device_train_batch_size 20 --per_device_eval_batch_size 8 --save_steps 10000 --evaluation_strategy steps --eval_steps 10000 --overwrite_cache --num_train_epochs 100 --block_size 512
```

Fine-tune casual GPT-2 language model on the buddhist sanskrit corpus:<br/>

```
python fine-tune-clm.py --output_dir models_reference_corpus_gpt2_fine_tuned --train_file resources/lm_train.txt --validation_file resources/lm_test.txt --model_name_or_path models_reference_corpus_gpt2/checkpoint-20000 --do_train true --do_eval true --per_device_train_batch_size 20 --per_device_eval_batch_size 8 --save_steps 10000 --evaluation_strategy steps --eval_steps 10000 --overwrite_cache --num_train_epochs 50 --block_size 512 
```

#### Extract embeddings:<br/>

Build vocabulary, i.e., select words for which embeddings will be generated and map them to lemmas. The script takes 
the path to preprocessed buddhist corpus as an input and returns a pickled vocabulary file used in the next step and a list of words and its frequencies in a csv format as output:<br/>

```
python build_vocab.py --data_path resources/corpus_preprocessed.tsv --output_dir resources --tokenizer tokenizers/sanskrit.json
```

Generate embeddings:<br/>

```
python make_averaged_bert_embeddings.py --vocab_path resources/vocab.pickle --embeddings_path embeddings/embeddings.pickle --path_to_fine_tuned_model models_reference_corpus_fine_tuned --model_type BERT --layer_config all --batch_size 16 --max_sequence_length 256 --device cuda
```

**Arguments:**<br/>
**--vocab_path** Paths to vocab pickle file generated by the preprocessing.py script <br/>
**--embeddings_path** Path to output pickle file containing embeddings. <br/>
**--layer_config** Which encoder layers to take to generate embedding, options are 'all', 'last_4', 'first_6' <br/>
**--path_to_fine_tuned_model** Path to fine-tuned model <br/>
**--model_type** BERT or GPT-2 <br/>

**Outputs:**<br/>
output pickle file containing embeddings

#### Embedding evaluation:<br/>

Evaluate embeddings on the analogy task:<br/>

```
python analogies_model_evaluate.py --embeddings_path embeddings/embeddings_all_layers.pickle
```

Evaluate embeddings on the simlex task:<br/>

```
python simlex_evaluation.py --embeddings_path embeddings/embeddings_all_layers.pickle --simlex_path resources/AllPairsScored_v3_2021-10-20.csv
```


## Static Embeddings Experiments ##

The code for experiments with the static embeddings is contained in 'static_embeddings_experiments' directory. The experiments for fasttext and word2vec algorithms are additionally separated into their respective directories.

### Preprocessing the data ###

For the purpose of training the static embeddings models, the buddhist sanskirt corpus (in directory 'resources/BuddhCorpus_v2c_IncludesReconstructions_2021-11-11) needs to be preprocessed. To preprocess the original buddhist sanskirt corpus, run the script 'data_preperation.py' in 'static_embeddings_experiments/data_preparation' directory. The script will output the preprocessed corpus.

### Training the fasttext and word2vec models ###

To train the buddhist sanskirt models, run the script 'fasttext_model_train.py' (for fasttext algorithm) or 'word2vec_model_train.py' (for word2vec algorithm). The scripts take the path to the preprocessed training data as an argument.<br/>

Example:<br/>
```
python fasttext_model_train.py --data_path <absolute_path_to_preprocessed_corpus>
```

You can optionally set the file where you want to save the trained model as well as the hyperparameters of the algorithms.<br/>

**fasttext arguments:**<br/>
**--data_path** Path to the preprocessed training corpus.<br/>
**--model_path** Path where the trained fasttext model will be saved.<br/>
**--vector_size** Dimensions of the embeddings space.<br/>
**--window_size** Size of the context window for calculating the embeddings.<br/>
**--epochs** Number of epochs.<br/>
**--model** Either 'cbow' or 'skipgram'.<br/>
**--minn** Minimum length of the subword ngrams.<br/>
**--maxn** Maximum length of the subword ngrams.<br/>

**word2vec arguments:**<br/>
**--data_path** Path to the preprocessed training corpus.<br/>
**--model_path** Path where the trained fasttext model will be saved.<br/>
**--vector_size** Dimensions of the embeddings space.<br/>
**--window_size** Size of the context window for calculating the embeddings.<br/>
**--epochs** Number of epochs.<br/>
**--model** Either 0 for cbow or 1 for skipgram.<br/>

### Running the hyperparameter optimization experiment ###

Run the script 'random_search.py' for the fasttext and word2vec algorithms from their respective directories. The script takes as the arguments the path to the training data. It outputs the trained models from the 100 hyperoptimization runs as well as the evaluation scores for each model on the subset of the analogy task. The metrics for all the models are gathered into a log file.<br/>

Example:<br/>
```
python random_search.py --data_path <absolute_path_to_preprocessed_corpus>
```

### Running the evaluation of the trained models on the analogy task ###

To run the analogy task evaluation, run the script 'analogy_evaluation.py' for the fasttext and word2vec algorithms from their respective directories. The script takes the path to the model you wish to evaluate as the input parameter. It outputs a log file with the scores on the 3 analogy tasks described in the paper.<br/>

Example:<br/>
```
python analogy_evaluation.py --model_path <absolute_path_to_preprocessed_corpus>
```

### Running the evaluation of the trained models on the simlex task ###

To run the simlex task evaluation, run the script 'simlex_evaluation.py' for the fasttext and word2vec algorithms from their respective directories. The script takes the path to the model you wish to evaluate as the input parameter. It outputs a log file with the scores on the 3 analogy tasks described in the paper.<br/>

Example:<br/>
```
python simlex_evaluation.py --model_path <absolute_path_to_preprocessed_corpus>
```

### Extra: running the script to obtain word synonyms ###

You can use the embedding models to obtain word synonyms:


Example (with fasttext embeddings):<br/>
```
python get_synonyms.py --words 'dāna,ghoṣa' --embeddings_path 'static_embeddings_models/fasttext/model_56.bin' --embeddings_type 'fasttext'
```

Example (with BERT embeddings):<br/>
```
python get_synonyms.py --words 'dāna,ghoṣa' --embeddings_path 'embeddings/bert_buddhist_all_tokens_300_epochs_all_layers.pickle' --embeddings_type 'bert'
```

Example (with BERT small embeddings):<br/>
```
python get_synonyms.py --words 'dāna,ghoṣa' --embeddings_path 'embeddings/buddhist_lemmatized_bert_small.pickle' --embeddings_type 'bert_small'
```


### Extra: Jupyter notebook for training a model for word sense disambiguation on Colab ###

Use the script sanskrit_sense_disambiguation.ipynb to train a binary classification model on Colab. 
The model needs to be trained on the dataset with labeled target lemmas with senses (i.e., for example 
on the 'LexicalDataForNLPteamWithMetadata_2022-06-23.csv' dataset).
Once trained, the model takes two sentences with the same target lemma as an input and determines whether the lemma 
in these two sentences has the same meaning or not.

